// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011, 2012 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// ClassBroadphaseInterface.h

// 

#include "wchar.h"
#ifndef _DEFINED_HG3D_ClassBroadphaseInterface
#define _DEFINED_HG3D_ClassBroadphaseInterface

#include "ClassPtr.h"
#include "ClassDispatcher.h"
#include "StructVec3.h"



// 
void bt_brdpintf_destruct(struct hg3dclass_struct * thisclass_c);

// calculateOverlappingPairs is optional: incremental algorithms (sweep and prune) might do it during the set aabb 
void bt_brdpintf_calculateOverlappingPairs(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * dispatcher_c);

// 
void bt_brdpintf_getBroadphaseAabb(struct hg3dclass_struct * thisclass_c, struct vector3_struct * aabbMin_c, struct vector3_struct * aabbMax_c);

// reset broadphase internal structures, to ensure determinism/reproducability 
void bt_brdpintf_resetPool(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * dispatcher_c);

// 
void bt_brdpintf_printStats(struct hg3dclass_struct * thisclass_c);

#endif 
