// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011, 2012 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// ClassDynamicsWorld.h

// 

#include "wchar.h"
#ifndef _DEFINED_HG3D_ClassDynamicsWorld
#define _DEFINED_HG3D_ClassDynamicsWorld

#include "ClassPtr.h"
#include "ClassActionInterface.h"
#include "StructVec3.h"
#include "ClassRigidBody.h"



// 
void bt_dnmcwrld_destruct(struct hg3dclass_struct * thisclass_c);

// 
void bt_dnmcwrld_stepSimulation(struct hg3dclass_struct * thisclass_c, float timeStep_c, int maxSubSteps_c, float fixedTimeStep_c, int * result_c);

// 
void bt_dnmcwrld_debugDrawWorld(struct hg3dclass_struct * thisclass_c);

// 
void bt_dnmcwrld_addAction(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * action_c);

// 
void bt_dnmcwrld_removeAction(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * action_c);

// 
void bt_dnmcwrld_setGravity(struct hg3dclass_struct * thisclass_c, struct vector3_struct * gravity_c);

// 
void bt_dnmcwrld_getGravity(struct hg3dclass_struct * thisclass_c, struct vector3_struct * result_c);

// 
void bt_dnmcwrld_synchronizeMotionStates(struct hg3dclass_struct * thisclass_c);

// 
void bt_dnmcwrld_addRigidBody(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * body_c);

// 
void bt_dnmcwrld_removeRigidBody(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * body_c);

// 
void bt_dnmcwrld_getNumConstraints(struct hg3dclass_struct * thisclass_c, int * result_c);

// 
void bt_dnmcwrld_clearForces(struct hg3dclass_struct * thisclass_c);

// obsolete, use addAction instead. 
void bt_dnmcwrld_addVehicle(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * vehicle_c);

// obsolete, use removeAction instead 
void bt_dnmcwrld_removeVehicle(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * vehicle_c);

// obsolete, use addAction instead. 
void bt_dnmcwrld_addCharacter(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * character_c);

// obsolete, use removeAction instead 
void bt_dnmcwrld_removeCharacter(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * character_c);

#endif 
