// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011, 2012 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// ClassHG3DBulletMotionStateHandler.h

// 

#include "wchar.h"
#ifndef _DEFINED_HG3D_ClassHG3DBulletMotionStateHandler
#define _DEFINED_HG3D_ClassHG3DBulletMotionStateHandler

#include "ClassPtr.h"
#include "ClassMotionState.h"
#include "StructVec3.h"
#include "StructQuaternion.h"
#include "ClassRigidBody.h"



// 
void bt_hg3dblmsh_createDefaultMotionState(struct vector3_struct * pos_c, struct quaternion_struct * qt_c, struct hg3dclass_struct * result_c);

// 
void bt_hg3dblmsh_getPosition(struct hg3dclass_struct * rb_c, struct vector3_struct * result_c);

// 
void bt_hg3dblmsh_setPosition(struct hg3dclass_struct * rb_c, struct vector3_struct * pos_c);

// 
void bt_hg3dblmsh_getQuaternion(struct hg3dclass_struct * rb_c, struct quaternion_struct * result_c);

// 
void bt_hg3dblmsh_setQuaternion(struct hg3dclass_struct * rb_c, struct quaternion_struct * rot_c);

#endif 
