// This source file is part of HGamer3D
// (A project to enable 3D game development in Haskell)
// For the latest info, see http://www.althainz.de/HGamer3D.html
// 
// (c) 2011, 2012 Peter Althainz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// ClassSimpleDynamicsWorld.h

// 

#include "wchar.h"
#ifndef _DEFINED_HG3D_ClassSimpleDynamicsWorld
#define _DEFINED_HG3D_ClassSimpleDynamicsWorld

#include "ClassPtr.h"
#include "StructVec3.h"
#include "ClassRigidBody.h"
#include "ClassActionInterface.h"



// 
void bt_smpldnwrld_destruct(struct hg3dclass_struct * thisclass_c);

// maxSubSteps/fixedTimeStep for interpolation is currently ignored for btSimpleDynamicsWorld
void bt_smpldnwrld_stepSimulation(struct hg3dclass_struct * thisclass_c, float timeStep_c, int maxSubSteps_c, float fixedTimeStep_c, int * result_c);

// 
void bt_smpldnwrld_setGravity(struct hg3dclass_struct * thisclass_c, struct vector3_struct * gravity_c);

// 
void bt_smpldnwrld_getGravity(struct hg3dclass_struct * thisclass_c, struct vector3_struct * result_c);

// 
void bt_smpldnwrld_addRigidBody(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * body_c);

// 
void bt_smpldnwrld_removeRigidBody(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * body_c);

// 
void bt_smpldnwrld_debugDrawWorld(struct hg3dclass_struct * thisclass_c);

// 
void bt_smpldnwrld_addAction(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * action_c);

// 
void bt_smpldnwrld_removeAction(struct hg3dclass_struct * thisclass_c, struct hg3dclass_struct * action_c);

// 
void bt_smpldnwrld_updateAabbs(struct hg3dclass_struct * thisclass_c);

// 
void bt_smpldnwrld_synchronizeMotionStates(struct hg3dclass_struct * thisclass_c);

// 
void bt_smpldnwrld_clearForces(struct hg3dclass_struct * thisclass_c);

#endif 
